'use strict';

/* eslint-env browser */

var React = require('react');
var ReactDOM = require('react-dom');

var _require = require('react-router-config'),
    renderRoutes = _require.renderRoutes;

var _require2 = require('react-router-dom'),
    BrowserRouter = _require2.BrowserRouter;

var _require3 = require('react-redux'),
    Provider = _require3.Provider;

var clientRouterCreator = require('../tool/clientRouterCreator');
var storeCreator = require('../tool/storeCreator');
var rootSaga = require('../tool/rootSagaCreator');

// 会在build阶段，用webpack.DefinePlugin替换global.__CLIENT_ROUTER__
var clientRouters = clientRouterCreator(global.__CLIENT_ROUTER__);

// prepare initialState for client state
var initialState = {};
if (typeof window !== 'undefined') {
  initialState = window.FUNSEE_STATE;
}
// create store & run the saga
var store = storeCreator(initialState);
store.runSaga(rootSaga());

ReactDOM.render(React.createElement(
  Provider,
  { store: store },
  React.createElement(
    BrowserRouter,
    null,
    renderRoutes(clientRouters)
  )
), document.getElementById('root'));

/* *************************************************************** */
/* TODO: 补充热更新细节                                              */
/* *************************************************************** */
if (module.hot) {
  module.hot.accept();
}